﻿using UnityEngine;
using System.Collections;

public class CoinCollect : MonoBehaviour
{
    private bool safe = false;
    public void OnTriggerEnter(Collider other)
    {
        SendMessageUpwards("CollectedCoin", transform.position, SendMessageOptions.DontRequireReceiver);
        Destroy(gameObject);
    }


    // Use this for initialization
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        if (!safe)
        {
            bool trapped = checkBreathingRoom();
            if (trapped)
            {
                SendMessageUpwards("DeletedCoin", SendMessageOptions.DontRequireReceiver);
                Destroy(gameObject);
            }
            else
            {
                GetComponent<MeshRenderer>().enabled = true;
                //transform.position += Random.onUnitSphere * 0.25f;
            }
        }
        safe = true;
    }

    bool checkBreathingRoom()
    {
        bool trapped = false;
        if (transform.position.x >= 0) trapped = trapped || Physics.Raycast(new Vector3(10, transform.position.y, transform.position.z), new Vector3(-1, 0, 0), 10);
        if (transform.position.x <= 0) trapped = trapped || Physics.Raycast(new Vector3(-10, transform.position.y, transform.position.z), new Vector3(1, 0, 0), 10);
        if (transform.position.y >= 0) trapped = trapped || Physics.Raycast(new Vector3(transform.position.x, 10, transform.position.z), new Vector3(0,-1, 0), 10);
        if (transform.position.y <= 0) trapped = trapped || Physics.Raycast(new Vector3(transform.position.x, -10, transform.position.z), new Vector3(0, 1, 0), 10);
        if (transform.position.z >= 0) trapped = trapped || Physics.Raycast(new Vector3(transform.position.x, transform.position.y, 10), new Vector3(0, 0, -1), 10);
        if (transform.position.z <= 0) trapped = trapped || Physics.Raycast(new Vector3(transform.position.x, transform.position.y, -10), new Vector3(0, 0, 1), 10);
        return trapped;
    }
}
