﻿using UnityEngine;
using System.Collections;



public class ProtoMovement : MonoBehaviour
{

    private Rigidbody rb;
    float xspeed = 4;
    float grav = 14;
    float jump = 6;
    bool jumpOK;
    private Vector3 startPosition;
    // Use this for initialization
    void Start()
    {
        rb = GetComponent<Rigidbody>();
        startPosition = transform.position;
    }

    public void OnCollisionStay(Collision collision)
    {
        if(collision.contacts[0].normal.y > 0.3f) jumpOK = true;
    }

    public void ResetPosition()
    {
        transform.position = startPosition;
        rb.velocity = Vector3.zero;
        gameObject.SetActive(false);
    }


    // Update is called once per frame
    void Update()
    {
        Vector3 control = new Vector2(Input.GetAxisRaw("Horizontal"), Input.GetAxisRaw("Vertical"));
        if (Input.GetButtonDown("Jump") && jumpOK)
        {
            rb.velocity = new Vector3(rb.velocity.x, jump, 0);
            jumpOK = false;
        }
        rb.velocity = new Vector3(control.x * xspeed, rb.velocity.y - grav * Time.deltaTime, 0);
        
    }
}
