﻿using UnityEngine;
using System.Collections;

public class Reorienter : MonoBehaviour {
    public float roomBounds = 4;
    private GameObject player;
    public enum movementDirection { RIGHT, LEFT, UP, DOWN};
    private movementDirection dir;
    public float movementRemaining;
    public float turnSpeed = 270/2;
	// Use this for initialization
	void Start () {
        player = GameObject.FindGameObjectWithTag("Player");
	}

    void ResetRotation()
    {
        movementRemaining = 0;
    }

	// Update is called once per frame
	void Update () {
        if (movementRemaining > 0)
        {
            player.SetActive(false);
            float decrement = Mathf.Min(movementRemaining, turnSpeed * Time.deltaTime);
            movementRemaining -= decrement;
            if (dir == movementDirection.DOWN)
                transform.Rotate(Vector3.right, decrement, Space.World);
            if (dir == movementDirection.UP)
                transform.Rotate(Vector3.left, decrement, Space.World);
            if (dir == movementDirection.RIGHT)
                transform.Rotate(Vector3.up, decrement, Space.World);
            if (dir == movementDirection.LEFT)
                transform.Rotate(Vector3.down, decrement, Space.World);

        }
        else
        {
            if (GetComponent<DistributeCubes>().levelTimer > 0 && GetComponent<DistributeCubes>().cleared == false)
                player.SetActive(true);
            else player.SetActive(false);
        }

        if (player.transform.position.y > roomBounds) RotateUp();
        if (player.transform.position.y < -roomBounds) RotateDown();
        if (player.transform.position.x > roomBounds) RotateRight();
        if (player.transform.position.x < -roomBounds) RotateLeft();


    }

    void RotateUp()
    {
        if (!player.activeSelf) return;
        player.SetActive(false);
        movementRemaining = 90;
        dir = movementDirection.UP;
        player.transform.position += new Vector3(0, -roomBounds * 2, 0);
    }
    void RotateDown()
    {
        if (!player.activeSelf) return;
        player.SetActive(false);
        movementRemaining = 90;
        dir = movementDirection.DOWN;
        player.transform.position += new Vector3(0, roomBounds * 2, 0);
    }
    void RotateLeft()
    {
        if (!player.activeSelf) return;
        player.SetActive(false);
        movementRemaining = 90;
        dir = movementDirection.LEFT;
        player.transform.position += new Vector3(roomBounds * 2, 0, 0);
    }
    void RotateRight()
    {
        if (!player.activeSelf) return;
        player.SetActive(false);
        movementRemaining = 90;
        dir = movementDirection.RIGHT;
        player.transform.position += new Vector3(-roomBounds * 2,0, 0);
    }

}
